#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1400eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 1400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight14004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight14004xi = {
                1:'-100x-1075y-890z',
                2:'-1011x-673y-695z',
                3:'-1028x-464y-827z',
                4:'-103x-1384y-181z',
                5:'-103x-470y-1314z',
                6:'-1051x-622y-683z',
                7:'-1059x-413y-816z',
                8:'-107x-268y-1369z',
                9:'-1087x-359y-805z',
                10:'-1088x-570y-671z',
                11:'-1112x-304y-793z',
                12:'-1122x-515y-658z',
                13:'-1134x-247y-782z',
                14:'-1153x-188y-770z',
                15:'-1154x-458y-646z',
                16:'-1169x-129y-758z',
                17:'-1182x-399y-633z',
                18:'-1208x-338y-621z',
                19:'-1230x-276y-608z',
                20:'-127x-274y-1366z',
                21:'-131x-476y-1309z',
                22:'-13x-205y-1384z',
                23:'-144x-941y-1026z',
                24:'-147x-279y-1363z',
                25:'-158x-1077y-880z',
                26:'-160x-481y-1304z',
                27:'-169x-283y-1360z',
                28:'-175x-1378y-167z',
                29:'-190x-484y-1299z',
                30:'-191x-285y-1357z',
                31:'-195x-942y-1016z',
                32:'-214x-285y-1353z',
                33:'-215x-1076y-869z',
                34:'-220x-485y-1294z',
                35:'-237x-284y-1350z',
                36:'-246x-940y-1007z',
                37:'-247x-1369y-153z',
                38:'-251x-484y-1288z',
                39:'-261x-281y-1346z',
                40:'-26x-218y-1382z',
                41:'-274x-1071y-858z',
                42:'-283x-482y-1283z',
                43:'-285x-276y-1342z',
                44:'-298x-936y-997z',
                45:'-2x-192y-1386z',
                46:'-309x-270y-1338z',
                47:'-30x-1385y-195z',
                48:'-315x-477y-1277z',
                49:'-319x-1355y-139z',
                50:'-332x-1063y-847z',
                51:'-333x-262y-1334z',
                52:'-347x-470y-1272z',
                53:'-350x-928y-987z',
                54:'-357x-251y-1329z',
                55:'-379x-461y-1266z',
                56:'-381x-239y-1325z',
                57:'-390x-1052y-835z',
                58:'-390x-1338y-125z',
                59:'-402x-917y-977z',
                60:'-405x-226y-1320z',
                61:'-40x-230y-1380z',
                62:'-411x-450y-1260z',
                63:'-428x-210y-1316z',
                64:'-43x-1070y-901z',
                65:'-43x-930y-1045z',
                66:'-443x-437y-1253z',
                67:'-448x-1038y-824z',
                68:'-451x-192y-1311z',
                69:'-454x-904y-967z',
                70:'-460x-1317y-111z',
                71:'-472x-173y-1306z',
                72:'-475x-421y-1247z',
                73:'-493x-152y-1301z',
                74:'-505x-1021y-813z',
                75:'-506x-403y-1241z',
                76:'-506x-887y-957z',
                77:'-513x-129y-1295z',
                78:'-528x-1292y-97z',
                79:'-532x-104y-1290z',
                80:'-536x-384y-1234z',
                81:'-549x-78y-1285z',
                82:'-54x-484y-1418z',
                83:'-557x-867y-946z',
                84:'-55x-241y-1377z',
                85:'-562x-1000y-801z',
                86:'-566x-362y-1227z',
                87:'-566x-50y-1279z',
                88:'-595x-337y-1221z',
                89:'-596x-1263y-83z',
                90:'-607x-845y-936z',
                91:'-618x-976y-790z',
                92:'-623x-311y-1214z',
                93:'-649x-283y-1207z',
                94:'-656x-819y-926z',
                95:'-661x-1231y-69z',
                96:'-673x-948y-778z',
                97:'-674x-253y-1200z',
                98:'-698x-221y-1192z',
                99:'-704x-790y-915z',
                100:'-71x-251y-1375z',
                101:'-720x-187y-1185z',
                102:'-725x-1195y-55z',
                103:'-726x-918y-767z',
                104:'-751x-759y-904z',
                105:'-76x-461y-1319z',
                106:'-778x-884y-755z',
                107:'-787x-1156y-41z',
                108:'-796x-724y-894z',
                109:'-829x-848y-743z',
                110:'-840x-687y-883z',
                111:'-847x-1114y-27z',
                112:'-877x-808y-731z',
                113:'-882x-648y-872z',
                114:'-89x-260y-1372z',
                115:'-904x-1068y-13z',
                116:'-922x-605y-861z',
                117:'-924x-766y-719z',
                118:'-93x-937y-1035z',
                119:'-959x-1019y0z',
                120:'-960x-561y-850z',
                121:'-969x-721y-707z',
                122:'-995x-513y-839z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1400eight4xi" usage = "target function for charge1400eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1400eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1400EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1400EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1400EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1400EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1400EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight14004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1400EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1400EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1400EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight14004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight14004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1400EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1400EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1400EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1400eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  